import random

macends=["46", "40", "41", "42", "43", "44", "45", "4F", "47", "48", "49", "4A", "4B", "4C", "4D", "4E", "00", "01", "02", "03", "04", "05", "06", "07", "08", "09", "0A", "0B", "0C", "0D", "0E", "0F", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "1A", "1B", "1C", "1D", "1E", "1F", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "2A", "2B", "2C", "2D", "2E", "2F", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "3A", "3B", "3C", "3D", "3E", "3F", "50", "51", "52", "53", "54", "55", "56", "57", "58", "59", "5A", "5B", "5C", "5D", "5E", "5F", "60", "61", "62", "63", "64", "66", "65", "67", "68", "69", "6A", "6B", "6C", "6D", "6E", "6F", "70", "71", "72", "73", "74", "75", "76", "77", "78", "79", "7A", "7B", "7C", "7D", "7E", "7F", "80", "81", "82", "83", "84", "85", "86", "87", "88", "89", "8A", "8B", "8C", "8D", "8E", "8F", "90", "91", "92", "93", "94", "95", "96", "97", "98", "99", "9A", "9B", "9C", "9D", "9E", "9F"]
random.shuffle(macends)
f=open('home_zone','w')

b="""#!/bin/bash
# 13/08/2013
#This is dicamarques edition of the script with mac changed to the ones from the list here https://docs.google.com/spreadsheet/lv?key=0AvvH5W4E2lIwdEFCUkxrM085ZGp0UkZlenp6SkJablE and easier wlan config
#
# wifi_zone_new
#  A script that emulates a Nintendo Zone in a way that you can actually connect to
#  other people all over the world.
#
# Initial version written by Somebunny (9. August 2013).
#

#
# documentation (sort of)
#
# You will need the following packages/programs:
#  - rfkill
#  - dnsmasq (will be killed if already running)
#  - hostapd (will be killed if already running)
# You should not need any additional configuration work.
#
# This script MUST be run as root, or using sudo, reconfiguring network
#  interfaces does not seem to work when run by non-root.
#
# Please adapt the following sections to your own computer:
#  - variables "zone" and "world", found below
#  - you can add hotsopts in "InitZone()", just copy what is there
#
# Usage: call the script with one extra parameter that describes the
#  MAC address to use. I have prepared some options that work from
#  the thread in the gbatemp forums.
#
# Shutdown: call the script with the parameter "stop".
#
#
# A first attempt to organise everything in a somewhat smarter way.
#

# First, some obligatory checks.
if [[ $EUID -ne 0 ]]; then
   echo "This script must be run as root or with sudo."
   echo "I don't like this either, but some calls here are really picky!"
   exit 1
fi

# some global settings; you should only need to adapt them for your system once
#  * this is the network interface used for your custom AP; must be wireless
zone=$2
#  * this is the network interface used to access the internet; can be almost anything
world=$3

# some local variables; using default values so that something is there
ssid="attwifi"
mac=4E:53:50:4F:4F:46
country=DE
name="Main MAC (All/Any)"

#
# local function that sets up the local variables;
#  crude but better than having to change the script every time
# NOTE: this part should be heavily modified so that it doesn't
#  depend on a static config. Maybe something with an external
#  file or something, so you don't have to share your relay point
#  with the entire world if you don't want to.
#
InitZone() {
  # kill all existing support tools
  killall dnsmasq 2> /dev/null
  killall hostapd 2> /dev/null
  # flush routing entries
  iptables --flush
  # deconfigure network interface
  /sbin/ifconfig $zone down
  case $1 in
    "stop")
      # emergency exit - restore old network state
      echo "Stopping Nintendo Zone hotspot"
      /etc/init.d/network-manager restart # yeah... didn't find a better way to fix it...
      exit
    ;;
    "random") #thanks to duke_srg for this. Edit the title line with the games you have. The default has Mk7, Super Mario 3D world and AC:NL
#For more codes see https://docs.google.com/spreadsheet/ccc?key=0Ajsweg1Cjr5_dGhlaDNfd2Fid0ZpNTBYQ2pwVUlLT3c#gid=0 just add the ctr code here
#everytime you run random it picks a different mac, so once you get mk, then ac...
TITLES=AMKAREEGD
BASE=NSP
RANDOM=$(head -c 2 /dev/urandom | hexdump -e '1/2 "%u"')
CTR=$(($RANDOM%$(($(expr length $TITLES)/3))))
mac=$(echo $BASE$TITLES | cut -c 1-3,$(($CTR*3+4))-$(($CTR*3+6)) | hexdump -e '6/1 "%02X:"' | head -c 17)
      ssid="attwifi"
      country=DE
      name="Random MAC from custom title list"
    ;;
    "default")
      # default settings, my old WiFi card that recently died
"""
e="""
    "milan")
      ssid="attwifi"
      mac=d8:6c:e9:f3:eb:96
      country=DE
      name="DONT UsE THis ONE!"
;;

  esac
}

# networkmanager often leaves a lock on the wireless hardware, remove it
rfkill unblock wifi

# set up parameters
InitZone $1

# give our wifi device a static IP address in the correct range so hostapd can associate with it
/sbin/ifconfig $zone hw ether $mac
/sbin/ifconfig $zone 192.168.23.1 up

# start dnsmasq
dnsmasq -i $zone --dhcp-range=192.168.23.50,192.168.23.150,255.255.255.0,12h

# enable IP forwarding
echo 1 > /proc/sys/net/ipv4/ip_forward

# set basic routes so that our associated devices can reach the web
iptables --flush
iptables --table nat --flush
iptables --delete-chain
iptables --table nat --delete-chain
iptables --table nat --append POSTROUTING --out-interface $world -j MASQUERADE
iptables --append FORWARD --in-interface $zone -j ACCEPT

sysctl -w net.ipv4.ip_forward=1

# start hostapd, spawn a temporary file
TMPDIR=`mktemp -d`
tmpfile=$TMPDIR/nztmp
echo $tmpfile
trap "rm -rf $TMPDIR" EXIT

echo "interface=${zone}" >> $tmpfile
echo "driver=nl80211" >> $tmpfile
echo "channel=1" >> $tmpfile
echo "ssid=${ssid}" >> $tmpfile
echo "auth_algs=1" >> $tmpfile
echo "wpa=0" >> $tmpfile
echo "country_code=${country}" >> $tmpfile
# uncomment the following two lines if you want MAC filtering
#echo "macaddr_acl=1" >> $tmpfile
#echo "accept_mac_file=/home/ms/hostapd/hostapd_mac_file" >> $tmpfile

echo "Starting Nintendo Zone hotspot, using config ''${name}''"
echo "SSID: ${ssid}"
echo "MAC: ${mac}"

hostapd $tmpfile -B -d > /dev/null 2> /dev/null

rm -rf $TMPDIR
"""
s=''
s+=b
s+='\n  ;;\n'
n=0
for i in macends:
    n+=1
    s+='    "spoof'+str(n)+'")\n'
    s+='      ssid="attwifi"\n'
    s+='      mac=4E:53:50:4F:4F:'+str(i)+'\n'
    s+='      country=DE\n'
    s+='      name="Spoof '+str(n)+'"\n'
    s+='  ;;\n'
s+=e
f.write(s)
f.close()